package il.ac.tau.cs.software1.simplesearch;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.List;

public class Main {
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Main().run();
	}
	
	/**
	 * The driving engine of the application. Starts by indexing 
	 * the specified URLs, the goes into a loop of searches.
	 * You may exit the search loop by typing "(exit)". 
	 */
	private void run() {
		WordIndex indexer = new WordIndex();
		indexURLs(indexer);
		doSearches(indexer);
	}

	/**
	 * index the specified URLs
	 */
	private static void indexURLs(WordIndex indexer) {
		for (String strURL : strURLs) {
			System.out.println("Indexing \"" + strURL + "\" ...");
			indexer.index(HTMLTokenizer.getTokens(strURL), strURL);
		}
	}
	
	/**
	 * search loop
	 */
	private static void doSearches(WordIndex indexer) {
		
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
			String str = null;
			do {
				System.out.print("> ");
				str = in.readLine().trim();
				if (str.equals("(exit)")) {
					break;
				}
				List<String> results = indexer.search(str);
				if (results == null  || results.size() == 0) {
					System.out.println("Unable to find the word you requested");
				} else {
					for (int i = 0; i < results.size(); ++i) {
						System.out.println(i + 1 + ".\t" + results.get(i));
					}
				}
			} while (true);

		} catch (IOException e) { }
		
		System.out.println("Thank you for using SimpleSearch");
	}

	/**
	 * a list of URLs we wish to index.
	 * feel free to add/remove urls from this list.
	 */
	static private String[] strURLs = {
		"http://en.wikipedia.org/wiki/Java_(programming_language)",
		"http://en.wikipedia.org/wiki/Java",
		"http://www.gutenberg.org/files/4300/4300-h/4300-h.htm",
		"http://www.java.com/en/",
		"http://www.gutenberg.org/files/11/11-h/11-h.htm",
		"http://www.gutenberg.org/files/12/12-h/12-h.htm",
		"http://www.gutenberg.org/files/27152/27152-h/27152-h.htm"
	};
}
